/* autodetect utmp formatu
 * by Marek Zelem
 */

#include <ctype.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <fcntl.h>
#include <paths.h>
#include <pwd.h>
#include <sys/types.h>
#include <sys/stat.h>

#define	MAXLEN	102400

char *utmp_file=_PATH_UTMP;
int len;
char utmp[MAXLEN];

typedef struct	{
	int ofs;
	char *type;
	int size;
	char *id;
		} z_t;

int compute_sizes( z_t *z, int n, int l )
{ int i,a,j,p,pa;
  z_t zz;
	a=0; p=0;
/* Zotriedenie */
	while( a<l )
	{	i=p; j= -1;
		while( i<n )
		{	if( z[i].ofs>=a && (j<0 || z[i].ofs<z[j].ofs) )	j=i;
			i++;
		}
		if( j<0 )	break;
		if( j>p )
		{	zz=z[p];
			z[p]=z[j];
			z[j]=zz;
			j=p;
		}
		p++;
		a++;
	}
/* Vypocitanie dlzok */
	for(i=0;i<n;i++)
	{	if( z[i].size<=0 )
		{	if( i+1<n && z[i+1].ofs>=0 )
				a=z[i+1].ofs - z[i].ofs;
			else	a=l-z[i].ofs;
			if( a<=0 )	return(-1);
			if( a>=256 )	z[i].size=256;
			else if( a>=64 )	z[i].size=64;
			else if( a>=32 )	z[i].size=32;
			else if( a==20 )	z[i].size=12;
			else if( a>=16 )	z[i].size=16;
			else if( a>=12 )	z[i].size=12;
			else if( a>=8 )		z[i].size=8;
			else			z[i].size=a;
		}
	}
/* Doplnenie neznamich poloziek */
	i=0;
	while( i<n && z[i].ofs>=0 )	i++;
	while( i<n && z[i].ofs<0 )
	{	j=0; p=-1; pa=0;
		while( j<n )
		{	if( j+1<n && z[j+1].ofs>=0 )
				a=z[j+1].ofs - z[j].ofs;
			else	a=l-z[j].ofs;
			a-=z[j].size;
			if( a==z[i].size )
			{	p=j; break;	}
			else if( a>z[i].size )
			{	if( p<0 || a<pa )
				{ p=j; pa=a; }
			}
			j++;
		}
		if( p<0 )	return(-1);
		z[i].ofs=z[p].ofs + z[p].size;
		zz=z[i];
		memmove(&(z[p+1]),&(z[p]),(i-p)*sizeof(z_t));
		z[p+1]=zz;
		i++;
	}
	return(0);
}

int zsizeof( char *id, z_t *z, int n )
{ int i;
	for(i=0;i<n;i++)
	{	if( !strcmp(z[i].id,id) )
			return(z[i].size);
	}
	return(0);
}

int printf_struct_decl( char *name, z_t *z, int n, int l )
{ int i,p,a,x;
	printf(	"struct %s\n{\n",name);
	p=0; x=1;
	for(i=0;i<n;i++)
	{	a=z[i].ofs - p;
		if( a!=0 )
			printf("\tchar unknown%d[%d];\n",x,a);
		printf("\t");
		printf(z[i].type,z[i].id);
		printf(";\n");
		p=z[i].ofs + z[i].size;
	}
	if( p!=l )
		printf("\tchar pad[%d];\n",l-p);
	printf(	"};\n\n");
	return(0);
}

/* detekovacie funkcie */

int find_string( int pos )
{ int i,j;
	i=pos;
F1:	while( i<len && !isalpha(utmp[i]) )	i++;
	j=i;
	while( j<len && (isalnum(utmp[j]) || utmp[j]=='/' || utmp[j]=='.' || utmp[j]==':') )
		j++;
	if( j<len && utmp[j]!=0 )
	{	i=j;	goto F1;	}
	if( j>=len )	return(-1);
	return(i);
}

int find_utname( int pos )
{
	while( 1 )
	{
		if( (pos=find_string(pos))<0 )	return(-1);
		if( !strcmp(utmp+pos,"runlevel") )	return(pos);
		if( !strcmp(utmp+pos,"LOGIN") )	return(pos);
		if( getpwnam(utmp+pos)!=NULL )	return(pos);
		pos++;
	}
}

int get_utentlen( void )
{ int p,l,a,x;
	l=0;
	p=0;
	a= -1;
	while( (p=find_utname(p))>=0 )
	{	if( l>0 )
		{	x=p-a;
			if( x<l && (l % x)==0 )	l=x;
			if( (x % l)!=0 )
			{
				return(-1);	/* !!! nieco inteligentnejsie*/
			}
			a=p;
		}
		else if( a<0 )
		{	a=p;
		}
		else
		{	l=p-a;
			a=p;
		}
		while( p<len && isalpha(utmp[p]) )	p++;
	}
	return(l);
}

int ishost( char *h )
{ int r;
	r=0;
	while( *h!=0 )
	{	if( *h=='.' )	r=1;
		if( *h==':' && h[1]=='S' )	return(1);
		if( *h==':' && h[1]=='0' )	return(1);
		h++;
	}
	return(r);
}

int find_pid( int pos, int l )
{ int n,i,j;
  int pid;
  static int opid[32],opidn[32],opp=0;
  struct stat st;
  char buf[32];
	n=l/sizeof(pid_t);
	for(i=0;i<n;i++)
	{	pid=*( (pid_t*)(utmp+pos+i*sizeof(pid)) );
		if( pid<10 || pid>65535 )	continue;
		sprintf(buf,"/proc/%d",pid);
		if( stat(buf,&st)<0 )	continue;
		j=0;
		while( j<opp && opid[j]!=i )	j++;
		if( j<opp )	opidn[j]++;
		if( j>=opp && opp<32 )
		{	opidn[opp]=1;
			opid[opp++]=i;
		}
	}
	i=0; n=0; j=-1;
	while( i<opp )
	{	if( n<opidn[i] )
		{ n=opidn[i]; j=i; }
		i++;
	}
	if( j<0 )	return(-1);
	return( sizeof(pid_t) * opid[j] );
}

int detect( void )
{ int l,n,i,p,a;
  int o_type,o_pid,o_line,o_id,o_time,o_user,o_host,o_addr;
  int otn,ot[8],otp[8];
  z_t z[16];
	o_type=o_pid=o_line=o_id=o_time=o_user=o_host=o_addr=-1;
	otn=0;
	l=get_utentlen();
	if( l<=0 )
	{	fprintf(stderr,"Can't detect size of utmp entry!\n");
		return(-1);
	}
	n=len/l;
	for(i=0;i<n;i++)
	{	p=i*l;
		a=find_utname(p);
		if( a>=0 && a<p+l && o_user<0 )	o_user=a-p;
		a=p;
		while( (a=find_string(a))>=0 && a<p+l )
		{	if( !strncmp(utmp+a,"tty",3) && o_line<0 )
				o_line=a-p;
			if( !strncmp(utmp+a,"/dev/tty",8) && o_line<0 )
				o_line=a-p;
			if( ishost(utmp+a) && o_host<0 )	o_host=a-p;
			a++;
		}
		if( o_user>=0 && getpwnam(utmp+p+o_user)!=NULL )
		{	a=0;
			while( a<l && utmp[p+a]!=7 )	a++;
			if( a<l )
			{ int b;
				b=0;
				while( b<otn && ot[b]!=a )	b++;
				if( b<otn )	otp[b]++;
				if( b>=otn && otn<8 )
				{	otp[otn]=1;
					ot[otn++]=a;
				}
			}
		}
		o_pid=find_pid(p,l);
	}
	a=0; n=0;
	while( a<otn )
	{	if( n<otp[a] )	{ n=otp[a]; o_type=ot[a]; }
		a++;
	}
	if( otn<=0 )
	{	fprintf(stderr,"Can't detect ut_type!\n");
		return(-1);
	}
	if( otn>1 )
		fprintf(stderr,"ut_type not exact detected\n");
	z[0].id="ut_type";
	z[0].ofs=o_type; z[0].type="short %s"; z[0].size=sizeof(short);
	z[1].id="ut_pid";
	z[1].ofs=o_pid; z[1].type="pid_t %s"; z[1].size=sizeof(pid_t);
	z[2].id="ut_line";
	z[2].ofs=o_line; z[2].type="char %s[UT_LINESIZE]"; z[2].size=0;
	z[3].id="ut_user";
	z[3].ofs=o_user; z[3].type="char %s[UT_NAMESIZE]"; z[3].size=0;
	z[4].id="ut_host";
	z[4].ofs=o_host; z[4].type="char %s[UT_HOSTSIZE]"; z[4].size=0;
	z[5].id="ut_id";
	z[5].ofs=-1; z[5].type="char %s[4]"; z[5].size=4;
	z[6].id="ut_time";
	z[6].ofs=-1; z[6].type="time_t %s"; z[6].size=sizeof(time_t);
	z[7].id="ut_addr";
	z[7].ofs=-1; z[7].type="long %s"; z[7].size=sizeof(long);
	if( compute_sizes(z,8,l) < 0 )
	{	fprintf(stderr,"Can't detect utmp entry!\n");
		return(-1);
	}
	printf(	"/* generated by autodetect_utmp\n"
		" */\n\n"
		"#define BAD_UTMP\n\n"
		"#include <features.h>\n"
		"#include <sys/types.h>\n"
		"#include <sys/time.h>\n"
		"#include <time.h>\n"
		"#include <sys/wait.h>\n"
		);
	if( utmp_file!=_PATH_UTMP )
		printf("#define _PATH_UTMP \"%s\"\n\n",utmp_file);
	else
		printf("#include <paths.h>\n\n");
	printf(	"// len=%d ut_type=%d ut_pid=%d ut_line=%d ut_user=%d\n"
		"// ut_host=%d\n\n", l,o_type,o_pid,o_line,o_user,o_host);
	printf(	"#define UT_LINESIZE\t%d\n",zsizeof("ut_line",z,8));
	printf(	"#define UT_NAMESIZE\t%d\n",zsizeof("ut_user",z,8));
	printf(	"#define UT_HOSTSIZE\t%d\n",zsizeof("ut_host",z,8));
	printf_struct_decl("real_utmp",z,8,l);
	return(0);
}

int main( int argc, char *argv[] )
{ int fd;
	if( argc>2 || (argc==2 && argv[1][0]=='-') )
	{	fprintf(stderr,"usage: %s [utmp filename]\n",argv[0]);
		return(-1);
	}
	if( argc==2 )	utmp_file=argv[1];
	if( (fd=open(utmp_file,O_RDONLY))<0 )
	{	fprintf(stderr,"Can't open utmp file %s\n",utmp_file);
		return(-1);
	}
	len=read(fd,utmp,MAXLEN);
	close(fd);
	return( detect() );
}
 
